Program CyberFileListCompilerforRenegade;

{ Copyright (C) 1995 by Tobin T. Fricke, All Rights Reserved.   }
{ This is freeware.  Use it, Copy It, Don't distribute modified }
{ copies.  This was originally bundled with CyberFile.          }

{ This creates a CyberFile "Generic Volume" out of your Renegade}
{ BBS's FBASES.DAT.                                             }

Uses CRT, Usefull;

{$I RECORDS.PAS}
{$I ACOLOR.INC}

Function RealLength(S:String):Word;
{ Determine the length of a string, minus the length of pipe codes }
{ (How much screen-space will it take up?)                         }
begin
 Repeat
  If Pos('^',S)>0 then Delete(S,Pos('^',S),2);
 Until Pos('^',S)=0;
 Repeat
  If Pos('|',S)>0 then Delete(S,Pos('|',S),3);
 Until Pos('|',S)=0;
 RealLength:=Length(S);
end;

Function Center(S:String; B:Byte):String;
{Center using RealLength instead of length}
var A:Byte;
Begin
 Repeat
  A:=RealLength(S) div 2;
  If A<(B Div 2) then S:=' '+S+' ';
 Until (RealLength(S) div 2)>=((B) Div 2);

 Repeat
  A:=RealLength(S);
  If A<B then S:=S+' ';
  If A>B then Delete(S,1,1);
 Until A=B;

 Center:=S;
End;


Function Left(S:String; B:Byte):String;
var A:Byte;
Begin
 Repeat
  A:=RealLength(S);
  If A<(B) then S:=S+' ';
 Until (RealLength(S))>=((B));
 Repeat
  A:=RealLength(S);
  If A<B then S:=S+' ';
  If A>B then Delete(S,length(S),1);
 Until A=B;

 Left:=S;
End;


Var F1:File of UlRec;
    F2:File of UlFRec;
    T1:Text;
    T2:Text;
    R1:UlRec;
    R2:UlFRec;

    RenePath:String;
    OutputFile:String;
    S:String;
    Size:Word;
Begin

 Writeln(' `ERENEGADE`F-->`ECYBERFILE`B `AGENERIC VOLUME `BConvert`3-`BO`3-`BMatic ');
 Writeln(' `3This program exports your FBASES.DAT into a CyberFile Generic Volume. ');
 Writeln('');
 Writeln(' USAGE: '+ParamStr(0)+' (PATH TO FBASES.DAT) (OUTPUT FILENAME) ');
 Writeln(' (OUTPUT FILENAME)  Must NOT have an extention  ');

 Writeln('');
 Writeln(' CREATING '+UpString(ParamStr(2))+'.VOL and '+UpString(ParamStr(2))+'.LST ');

 RenePath:=UpString(ParamStr(1));

 {Make sure there is a backslash on the end.}
 If Renepath[Length(Renepath)]<>'\' then Renepath:=Renepath+'\';

 Assign(F1,RenePath+'FBASES.DAT');      { F1 is the source file  FBASES.DAT }
 Assign(T1,ParamStr(2)+'.VOL');         { T1 is x.VOL, the volume file      }
 Assign(T2,ParamStr(2)+'.LST');         { T2 is x.LST, the data file        }


 Reset(F1);                             { Don't want to erase it!           }
 Rewrite(T1);
 Rewrite(T2);

 System.Writeln(T1,'DATAFILE '+UPSTRING(PARAMSTR(2))+'.LST');
 Writeln('');
 Writeln(' `B Please Wait, Working. ');

 Repeat
  Read(F1,R1);                               { Read a FileBase entry      }
  Write(#13+Usefull.Left(' `B Processing `3'+R1.Name,79));
  Assign(F2,RenePath+R1.Filename+'.DIR');    { Open up the .DIR file which}
  Reset(F2);                                 {  contains the headers.     }
  System.Writeln(T1,'AREA '+UpString(R1.Filename)+' '+R1.Name);
  System.Writeln(T2,'[##-'+UpString(R1.Filename)+'-##]');
  System.Writeln(T2,'|00|17Ŀ|16');
  System.Writeln(T2,'|00|17|15|17File Name  |09|17 |15|17Crs |09|17 |15|17Size |09|17 |15|17Description |11|17'+
  Left(R1.Name,37)+'|09|17|16');
  System.Writeln(T2,'|00|17|09|17|16');
{ Ŀ
  File Name   Crs  Size  Description     Uploads #2                      
  }
  Repeat
   Read(F2,R2);         { Read one file record            }
    begin               { Make an entry for the .LST file }
     S:=' |11'+Left(R2.Filename,13)+'|12'+Left(Center(Str(R2.Credits),4),5);
     Size:=0;
     Inc(Size,R2.Blocks*128);
     Inc(Size,R2.SizeMod);
     If Size<1024 then S:=S+'|09'+StrL(Size)+'|01b|15';
     If (Size>1024) and (Size<1024*1024) then S:=S+'|10'+StrL(Size div 1024)+'|02Kb|15';
     If (Size>1024*1024) then
     S:=S+'|12'+StrL(Size div (1024*1024))+'|04Mb|15';
     S:=Left(S,25);
     S:=S+'  '+R2.Description;
    end;
   System.Writeln(T2,S);        { Write the entry to the .LST record}
  Until EOF(F2);      { until there are no more files }
  System.Writeln(T2,'[##/END/##]');
  Write(#13+Left(' Please Wait, Saving... ',79));
  Close(F2);
 Until EOF(F1);
 Close(F1);
 Close(T1);
 Close(T2);
 Write(#13+Left('`B  - Done - ',79));
 Writeln('');
 Writeln(' `3 You might want to edit the files you just created to delete   ');
 Writeln(' `3 file bases you don''t want people to know about / have access ');
 Writeln(' `3 to. ');
 Writeln('');
End.