Program FileList;

{ Copyright (c) 1995 by Tobin T. Fricke - This is Freeware                 }
{ This program creates a list of your download directories in a text file. }
{ I use it to create my Requestable Directories List for Front Door.       }
{ For Renegade.                                                            }

Uses CRT,       { Comes with Borland Pascal}
     USEFULL,   { Written by Tobin Fricke  }
     TTY;       { Written by Tobin Fricke  }

Type

   acstring=string[20];

   fbflags= (fbnoratio,                    (* if <No Ratio> active                  *)
             fbunhidden,                   (* whether *VISIBLE* to users w/o access *)
             fbdirdlpath,                  (* if *.DIR file stored in DLPATH *)
             fbshowname,                   (* show uploaders in listings *)
             fbusegifspecs,                (* whether to use GifSpecs *)
             fbcdrom,                      (* base is read only, no sorting or ul scanning *)
             fbshowdate);                  (* show date uploaded in listings *)

  ulrec=Record                          (* FBASES.DAT  : File base records *)
    name:string[40];              (* area description  *)
    filename:string[12];          (* filename + ".DIR" *)
    dlpath,                       (* download path     *)
    ulpath:string[40];            (* upload path       *)
    maxfiles:word;                (* max files allowed *)
    password:string[20];          (* password required *)
    arctype,                      (* wanted archive type (1..max,0=inactive) *)
    cmttype:byte;                 (* wanted comment type (1..3,0=inactive) *)
    res1:integer;                 (* not used *)
    fbstat:set of fbflags;        (* file base status vars *)
    acs,                          (* access requirements *)
    ulacs,                        (* upload requirements *)
    dlacs:acstring;               (* download requirements *)
    res:array[1..10] of byte;     (* RESERVED *)
  end;

Procedure Write(S:String);
begin
 Repeat
  If S[1]='`' then
   begin
    If S[2] IN ['0'..'9','A'..'N'] then
     Begin
      If S[2] IN ['0'..'9'] then TextColor(Ord(S[2])-48);
      IF S[2] IN ['A'..'F'] then TextColor(Ord(S[2])-55);
      IF S[2] IN ['G'..'O'] then TextBackground(Ord(S[2])-71);
      Delete(S,1,2);
     End;
   end
   else
   begin
    System.Write(S[1]);
    Delete(S,1,1);
   end;
 Until S='';
end;

Procedure Writeln(S:String);
begin
 Write(S+#10+#13);
end;

Const Status:Array[1..4] of Char = ('|','/','-','\');
Var FN:String;
    F:File Of UlRec;
    B:Word;
    U:UlRec;
    D:Text;

begin
 TextAttr:=7;
 Writeln(' `FRenegade File Directory Exporter `7Version 1`8.`700');
 Writeln(' `9Copyright `1(`9C`1)`9 1994 by Tobin T`1.`9 Fricke`1,`9 All Rights Reserved`1.`7 ');
 Writeln(' `9Created using Borland Pascal 7`1.`900`1,`9 December 22`1,`9 1994`7');
 FN:=ParamStr(1);
 If FN[Length(FN)]<>'\' then FN:=FN+'\';
 FN:=FN+'FBASES.DAT';
 If (ParamCount<>2) or (Not FileExists(FN)) then
  begin
   Writeln(' `EUsage: `F RGFDE `8(`7RENEGADE DATA DIR`8) (`7DESTINATION FILE`8)`7 ');
   If Not FileExists(FN) Then Writeln(' `CERROR`4:`F  Cannot Locate `7'+FN);
   Halt;
  end;
 Write(' `FExporting`7....`9');
 B:=0;
 Assign(D,ParamStr(2));
 FileMode:=1;
 Rewrite(D);
 Assign(F,FN);
 FileMode:=0;
 Reset(F);
 Repeat
  Write(BS+Status[(B MOD 4)+1]);
  CRT.Delay(10);
  Read(F,U);
  System.Writeln(D,U.DLPATH);
  Inc(B);
 until EOF(F);
 Close(D);
 Close(F);
 Writeln(BS+'`7...`FDone`7  `1(`9Exported `F'+Str(B)+'`9 directories`1)`7');
 Writeln('');
 Writeln(' `3Call the `2Di`AGi`FTAL Fo`ARE`2ST`3 at (`B714`3) `B586`3-`B6142`9, `B28800`3bps`7');
end.